#pragma once

#include <mutex>

#include "flexpage.h"

/* A file accessor, providing flexpages corresponding to file regions. */

class Accessor
{
protected:
    offset_t _size;

public:
    fileid_t fileid;

    explicit Accessor(fileid_t fileid, offset_t size=0);

    virtual offset_t get_size();

    virtual void close();

    virtual void open();

    /* Data transfer methods. */

    virtual void fill(Flexpage *flexpage) = 0;

    virtual void flush(Flexpage *flexpage) = 0;
};

// vim: tabstop=4 expandtab shiftwidth=4
